summaryrefslogtreecommitdiff
path: root/localosmfeature2pdf
diff options
context:
space:
mode:
authorJonas Smedegaard <dr@jones.dk>2014-05-07 21:42:57 +0200
committerJonas Smedegaard <dr@jones.dk>2014-05-07 21:42:57 +0200
commit35a9ebd491ae3e83406459d16a1bc098835760fa (patch)
treefa323f2d6b50122cb4c520956e1b04db7c306a9c /localosmfeature2pdf
parent8268aad16e5b7b2f9b03bd4e358edc24b2d999a1 (diff)
Add new script localosmfeature2pdf.
Diffstat (limited to 'localosmfeature2pdf')
-rwxr-xr-xlocalosmfeature2pdf55
1 files changed, 55 insertions, 0 deletions
diff --git a/localosmfeature2pdf b/localosmfeature2pdf
new file mode 100755
index 0000000..64a89e0
--- /dev/null
+++ b/localosmfeature2pdf
@@ -0,0 +1,55 @@
+#!/bin/sh
+#
+# Copyright © 2014 Jonas Smedegaard <dr@jones.dk>
+# Description: resolve GeoJSON from OSM node, way and relation objects.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+# Depends: gdal-bin perl-modules
+
+set -eu
+
+# type must be either polygons, lines or points
+type="$1"
+feature="$2"
+outstem="${3:-$(basename "$feature")}"
+
+case "$feature" in
+ node/*)
+ url="http://www.openstreetmap.org/api/0.6/$feature"
+ ;;
+ *)
+ url="http://www.openstreetmap.org/api/0.6/$feature/full"
+ ;;
+esac
+case "$type" in
+ polygons)
+ ogr2ogr -t_srs EPSG:3857 -f PDF \
+ "$outstem.pdf" /vsicurl_streaming/"$url" \
+ --config OSM_USE_CUSTOM_INDEXING NO \
+ -nlt PROMOTE_TO_MULTI multipolygons
+ ;;
+ lines)
+ ogr2ogr -t_srs EPSG:3857 -f PDF \
+ "$outstem.pdf" /vsicurl_streaming/"$url" \
+ --config OSM_USE_CUSTOM_INDEXING NO \
+ -nlt PROMOTE_TO_MULTI multilinestrings
+ ;;
+ points)
+ ogr2ogr -t_srs EPSG:3857 -f PDF \
+ "$outstem.pdf" /vsicurl_streaming/"$url" \
+ --config OSM_USE_CUSTOM_INDEXING NO \
+ points \
+ ;;
+esac